library("randomForest", lib.loc="~/R/i686-pc-linux-gnu-library/3.0")
x <- read.csv("~/Downloads/hola.csv", header=FALSE)
fold<-10
n <- nrow(x)
prop <- n%/%fold
x$V101 = as.factor(x$V101)
form =  V101 ~ .

newseq <- rank(runif(n))
k <- as.factor((newseq - 1)%/%prop + 1)
y <- unlist(strsplit(as.character(form), " "))[2]
vec.accuracy <- vector(length = fold)
accu<-list()
ind<-list()

for (i in seq(fold)) {
    FOREST_model <- randomForest(form, data=x[k!=i,],ntree=140,do.trace=FALSE,replace=TRUE,sampsize=nrow(x[k!=i,]))
    #print(FOREST_model)
    fcast <- predict(FOREST_model, newdata = x[k == i, ], type = "class")
    cm <- table(x[k == i, y], fcast)
    if(i==1)
    {
      tot_cm <- cm
    }
    else
    {
      tot_cm <- tot_cm+cm
    }
    accuracy <- sum(diag(cm))/sum(cm)
    vec.accuracy[i] <- accuracy
  }

avg.f1 <- mean(vec.accuracy)
#  avg.error <- 1 - avg.accuracy
cv <- avg.f1

